/*
	Engineering Test: Links Configuration
	Gordon Lee

*******************************************************************************

	@filename	cFontManager.h

	@description
		Class for a font manager

	@author		Gordon Lee
*/

#ifndef C_FONTMANAGER_H
#define C_FONTMANAGER_H
#pragma once

// Includes
#include <d3d9.h>
#include <d3dx9.h>
#include <map>
#include <stack>
#include <string>

// Namespace
namespace Test
{
////////////////////////////////////////////////////////////////////////////////
// Forward declarations
struct sRenderPacketText;

// Typedefs
typedef	std::map<std::string, LPD3DXFONT> FontMap;
typedef std::stack<sRenderPacketText *> TextStack;

class cFontManager
{
public:
				cFontManager();
				~cFontManager();

	bool		Initialize(LPDIRECT3DDEVICE9 _D3DDevice);

	LPD3DXFONT	CreateNewFont(std::string _fontName, unsigned _size, unsigned _weight);
	LPD3DXFONT	GetFont(std::string _fontName);

	void		PushTextPacket(sRenderPacketText *_textPacket);
	void		ClearTextStack(void);
	TextStack *	GetTextStack(void) { return &m_textStack; }

private:
	LPDIRECT3DDEVICE9 m_D3DDevice;
	FontMap m_fontMap;
	TextStack m_textStack;
};
////////////////////////////////////////////////////////////////////////////////
}

#endif
