/*
	Engineering Test: Links Configuration
	Gordon Lee

*******************************************************************************

	@filename	cInput.h

	@description
		Class for keyboard input

	@author		Gordon Lee
*/

#ifndef C_INPUT_H
#define C_INPUT_H
#pragma once

// Defines
#define NUM_KEYS 256

// Namespace
namespace Test
{
////////////////////////////////////////////////////////////////////////////////
class cInput
{
public:
	static cInput *	Instance(void);
	static cInput *	Create(void);
	static void		Destroy(void);
	bool			Initialize(void);

	void			Update(void);

	void			ProcessKeyDown(const unsigned _wp);
	void			ProcessKeyUp(const unsigned _wp);
	void			ProcessMouse(const unsigned _lp);

	bool			KeyPress(const unsigned _wp) const;
	bool			KeyDown(const unsigned _wp) const;
	bool			KeyRelease(const unsigned _wp) const;
	bool			KeyUp(const unsigned _wp) const;

private:
					cInput();
					~cInput();

	// Data members
	unsigned char m_keyState[NUM_KEYS];
	unsigned char m_prevKeyState[NUM_KEYS];
};
////////////////////////////////////////////////////////////////////////////////
// Global define
#define g_pcInput cInput::Instance()
}

#endif
